﻿using Accordion.Model;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;

using System.IO;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.UI;
using Windows.UI.ViewManagement;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236

namespace Accordion.Controls
{
    public sealed partial class InspectionItemPresenter : UserControl
    {
        private SolidColorBrush hasCommentColor = new SolidColorBrush(Colors.Green);
        private SolidColorBrush noCommentColor = new SolidColorBrush(Colors.Black);

        public string InspectionItemId
        {
            get
            {
                return (string)GetValue(InspectionItemIdProperty);
            }
            set { SetValue(InspectionItemIdProperty, value); }
        }

        // Using a DependencyProperty as the backing store for InspectionItemName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty InspectionItemIdProperty =
            DependencyProperty.Register("InspectionItemId", typeof(string), typeof(InspectionItemPresenter), new PropertyMetadata(null));

        public string InspectionItemName
        {
            get
            {
                return (string)GetValue(InspectionItemNameProperty);
            }
            set { SetValue(InspectionItemNameProperty, value); }
        }

        // Using a DependencyProperty as the backing store for InspectionItemName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty InspectionItemNameProperty =
            DependencyProperty.Register("InspectionItemName", typeof(string), typeof(InspectionItemPresenter), new PropertyMetadata(null));

        public object InspectionItemContent
        {
            get {
                return (object)GetValue(InspectionItemContentProperty);
            }
            set {
                SetValue(InspectionItemContentProperty, value);
            }
        }

        // Using a DependencyProperty as the backing store for InspectionItemContent.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty InspectionItemContentProperty =
            DependencyProperty.Register("InspectionItemContent", typeof(object), typeof(InspectionItemPresenter), new PropertyMetadata(null));

        public string ValidationErrorMessage
        {
            get { return (string)GetValue(ValidationErrorMessageProperty); }
            set { SetValue(ValidationErrorMessageProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ValidationErrorMessage.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ValidationErrorMessageProperty =
            DependencyProperty.Register("ValidationErrorMessage", typeof(string), typeof(InspectionItemPresenter), new PropertyMetadata(null));

        public bool IsValid
        {
            get {
                return (bool)GetValue(IsValidProperty);
            }
            set {
                SetValue(IsValidProperty, value);
            }
        }

        // Using a DependencyProperty as the backing store for IsValid.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty IsValidProperty =
            DependencyProperty.Register("IsValid", typeof(bool), typeof(InspectionItemPresenter), new PropertyMetadata(null));

        public string Comment
        {
            get
            {
                return (string)GetValue(CommentProperty);
            }
            set
            {
                SetValue(CommentProperty, value);
            }
        }

        // Using a DependencyProperty as the backing store for Comment.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty CommentProperty =
            DependencyProperty.Register("Comment", typeof(string), typeof(InspectionItemPresenter), new PropertyMetadata(null));

        public bool CommentEnabled
        {
            get
            {
                return (bool)GetValue(CommentEnabledProperty);
            }
            set
            {
                SetValue(CommentEnabledProperty, value);
            }
        }

        // Using a DependencyProperty as the backing store for Comment.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty CommentEnabledProperty =
            DependencyProperty.Register("CommentEnabled", typeof(bool), typeof(InspectionItemPresenter), new PropertyMetadata(false));




        public InspectionItemPresenter()
        {
            this.InitializeComponent();
            //AddPhotoButton.Click += new RoutedEventHandler(AddPhotoIcon_Tapped);
            //AddPhotoIcon.Tapped += new RoutedEventHandler(AddPhotoIcon_Tapped);
        }

        private void AddCommentIcon_Tapped(object sender, TappedRoutedEventArgs e)
        {
            var icon = (SymbolIcon)sender;
            FlyoutBase.ShowAttachedFlyout(icon);
        }

        private void ShowPhotoCollectionIcon_Tapped(object sender, TappedRoutedEventArgs e)
        {
        }

        //Note: We thought we required the ability to attach photos to individual items, but that is no longer the case.
        //So now I don't think this will even be used, but leaving most of it for now.
        private async void AddPhotoIcon_Tapped(object sender, RoutedEventArgs e)
        {

            FileOpenPicker photoPicker = new FileOpenPicker();
            photoPicker.ViewMode = PickerViewMode.List;
            photoPicker.FileTypeFilter.Add("*");
            photoPicker.SuggestedStartLocation = PickerLocationId.PicturesLibrary;
            try
            {
                IReadOnlyList<StorageFile> photos = await photoPicker.PickMultipleFilesAsync();

                if (photos.Count > 0)
                {
                    foreach (StorageFile photo in photos)
                    {
                        // Copy over to photo/item folder and add to model
                        //PhotoCollection.Add(new InspectionPhoto(photo.Name, string.Format("{0}{1}", PhotoCollection.Count + 1, photo.FileType), photo));
                    }
                }
            }
            catch (Exception ex)
            {
                var stackTrace = ex;
            }
        }

        private void RemovePhotoIcon_Tapped(object sender, TappedRoutedEventArgs e)
        {
        }

        private void AddPhotoCaptionIcon_Tapped(object sender, TappedRoutedEventArgs e)
        {
            //var inspectionPhoto = ((SymbolIcon)sender).DataContext as InspectionPhoto;
        }
    }
}
